# Test modules for caches

module AclTests

  def config_x_ONLY_acl_success_ONLY_acl_accept1(proxy)
    proxy.add_config("ACL Allow #{TesterConfig::ClientIP} - *")
    proxy.add_config("ACL Deny * - *")
  end

  def config_x_ONLY_acl_success_ONLY_acl_accept2(proxy)
    ip = TesterConfig::ClientIP.split('.')
    ipmask = "#{ip[0]}.#{ip[1]}.#{ip[2]}.0/24"
    proxy.add_config("ACL Allow #{ipmask} - *")
    proxy.add_config("ACL Deny * - *")
  end

  def config_x_ONLY_acl_success_ONLY_acl_accept3(proxy)
    ip = TesterConfig::ClientIP.split('.')
    ipmask = "#{ip[0]}.#{ip[1]}.0.0/255.255.0.0"
    proxy.add_config("ACL Allow #{ipmask} - *")
    proxy.add_config("ACL Deny * - *")
  end

  def config_x_ONLY_acl_fail_ONLY_acl_deny1(proxy)
    proxy.add_config("ACL Deny * - *")
  end

  def config_x_ONLY_acl_fail_ONLY_acl_deny2(proxy)
    proxy.add_config("ACL Deny #{TesterConfig::ClientIP} - *")
  end

  # FIXME need to test netmasks, destination, and port based ACLs.
  # Need to check proper cascade down a list of ACLs.
  # Need tweaks to test with and without NTP.

  def test_ONLY_acl_accept_ONLY_acl_success(server, proxy)
    # Check we can connect
    connect
    logout
  rescue FroxException
    @error = "Failed active passive switching: " + $!
    return false
  end

  def test_ONLY_acl_deny_ONLY_acl_fail(server, proxy)
    # Check a connection is approprateily denied
    connect # Expected to fail
    logout
    @error = "Connection not denied by ACL"
    return false
  rescue FroxException
    return true
  end
end
