# Test modules for caches



module HttpCacheTests

  def config_1_http_proxy(proxy)
    # Test HTTP Proxy download
    proxy.add_config("CacheModule HTTP")
    proxy.add_config("HTTPProxy " + FroxDefaults::HTTPProxy)
    # FIXME - need to be able to check file was downloaded cached
  end

  def config_1_http_proxy_failover(proxy)
    # Test correct failover when unable to contact http cache.
    proxy.add_config("CacheModule HTTP")
    proxy.add_config("HTTPProxy " + FroxDefaults::UncontactableHTTP)
  end
end

module LocalCacheTests
  
  def config_1_local_cache(proxy)
    proxy.add_config("CacheModule local")
  end

  def test_ONLY_local_cache_ONLY_localcache_integrity(server, proxy)
    #Lots of tests in here so we can control the order.
    proxy.restart(true) # Purge the cache
    connect
    passive(false)
    md5sum = server['ExistingFile'][0]
    filename = server['ExistingFile'][1]
    proxy.purgeLog
    retrieve(filename, md5sum)
    log = proxy.waitForLog(/DOWNLOADED/)
    cached = log.index(/CACHE_HIT/)
    if cached
      @error = "Returning cached files after purge"
      return false
    end

    retrieve(filename, md5sum)
    log = proxy.waitForLog(/DOWNLOADED/)
    cached = log.index(/CACHE_HIT/)
    shouldbecached = (server["User"]==nil)
    if (cached && !shouldbecached)
      @error = "Caching when we shouldnt"
      return false
    elsif (!cached && shouldbecached)
      @error = "Not caching when we should"
      return false
    end

    logout
    return true
  rescue FroxException
    @error = "Failed: " + $!
    return false
  end
end
