# General test modules applicable regardless of the options that frox is compiled with


module GeneralTests

  def test_apswitches(server, proxy)
    # test simple file retrieval in passive and active modes. Test switches
    # from active to passive as these have caused bugs in the past.
    # First test - active, active, passive, active
    # Second test - passive, passive, active, passive
    pasv=false
    md5sum = server['ExistingFile'][0]
    filename = server['ExistingFile'][1]
    2.times do
      connect
      4.times do |i|
	passive(pasv)
        retrieve(filename, md5sum)
	pasv=!pasv if i!=0
      end
      logout
    end
  rescue FroxException
    @error = "Failed active passive switching: " + $!
    return false
  end

  def test_failretrieve(server, proxy)
    # Test we continue to work after a failed downoad
    connect
    retrieve(server['NonExistantFile'], nil, true)

    md5sum = server['ExistingFile'][0]
    filename = server['ExistingFile'][1]
    retrieve(filename, md5sum)
    logout
  rescue FroxException
    @error = "Failed fail retrieve: " + $!
    return false
  end

  def test_simple_retr(server, proxy)
    # Test retrieves of several files, with some dir changing.
    server['ExistingFiles'].each { |path|
      connect
      md5sum = path[0]
      filename = path[-1]
      path.each_index { |i|
        cd(path[i]) if i!=0 && i!=path.size-1
      }
      retrieve(filename, md5sum)
      logout
    }
  rescue FroxException
    @error = "Failed simple retrieve: " + $!
    return false
  end
end

# Broken out from GeneralTests so they can be included separately
# Test runtime was getting too long!
module GeneralTweaks

  def config_0_apconv(proxy)
    proxy.add_config("APConv yes")
  end

  def config_0_paconv(proxy)
    proxy.add_config("PAConv yes")
  end

  def config_0_ntpaddress(proxy)
    proxy.add_config("NTPAddress " + TesterConfig::FroxIP + ":2121")
  end

  def config_0_dontchroot(proxy)
    proxy.add_config("DontChroot yes")
  end

end
